| M480 BSP V3.05.001 The Board Support Package for M480 Series

Macros | Typedefs | Functions | Variables
USBD Exported Functions
Standard Driver » USBD Driver

## Macros
#define | USBD_Maximum(a, b)
| Compare two input numbers and return maximum one. More...
#define | USBD_Minimum(a, b)
| Compare two input numbers and return minimum one. More...
#define | USBD_ENABLE_USB()
| Enable USB. More...
#define | USBD_DISABLE_USB()
| Disable USB. More...
#define | USBD_ENABLE_PHY()
| Enable USB PHY. More...
#define | USBD_DISABLE_PHY()
| Disable USB PHY. More...
#define | USBD_SET_SE0()
| Enable SE0. Force USB PHY transceiver to drive SE0. More...
#define | USBD_CLR_SE0()
| Disable SE0. More...
#define | USBD_SET_ADDR(addr)
| Set USB device address. More...
#define | USBD_GET_ADDR()
| Get USB device address. More...
#define | USBD_ENABLE_INT(intr)
| Enable USB interrupt function. More...
#define | USBD_GET_INT_FLAG()
| Get interrupt status. More...
#define | USBD_CLR_INT_FLAG(flag)
| Clear USB interrupt flag. More...
#define | USBD_GET_EP_FLAG()
| Get endpoint status. More...
#define | USBD_GET_BUS_STATE()
| Get USB bus state. More...
#define | USBD_IS_ATTACHED()
| Check cable connection state. More...
#define | USBD_STOP_TRANSACTION(ep)
| Stop USB transaction of the specified endpoint ID. More...
#define | USBD_SET_DATA1(ep)
| Set USB DATA1 PID for the specified endpoint ID. More...
#define | USBD_SET_DATA0(ep)
| Set USB DATA0 PID for the specified endpoint ID. More...
#define | USBD_SET_PAYLOAD_LEN(ep, size)
| Set USB payload size (IN data) More...
#define | USBD_GET_PAYLOAD_LEN(ep)
| Get USB payload size (OUT data) More...
#define | USBD_CONFIG_EP(ep, config)
| Configure endpoint. More...
#define | USBD_SET_EP_BUF_ADDR(ep, offset)
| Set USB endpoint buffer. More...
#define | USBD_GET_EP_BUF_ADDR(ep)
| Get the offset of the specified USB endpoint buffer. More...
#define | USBD_SET_EP_STALL(ep)
| Set USB endpoint stall state. More...
#define | USBD_CLR_EP_STALL(ep)
| Clear USB endpoint stall state. More...
#define | USBD_GET_EP_STALL(ep)
| Get USB endpoint stall state. More...

## Typedefs
typedef void(* | VENDOR_REQ) (void)
typedef void(* | CLASS_REQ) (void)
typedef void(* | SET_INTERFACE_REQ) (uint32_t u32AltInterface)
typedef void(* | SET_CONFIG_CB) (void)

## Functions
__STATIC_INLINE void | USBD_MemCopy (uint8_t dest[], uint8_t src[], uint32_t size)
| To support byte access between USB SRAM and system SRAM. More...
__STATIC_INLINE void | USBD_SetStall (uint8_t epnum)
| Set USB endpoint stall state. More...
__STATIC_INLINE void | USBD_ClearStall (uint8_t epnum)
| Clear USB endpoint stall state. More...
__STATIC_INLINE uint32_t | USBD_GetStall (uint8_t epnum)
| Get USB endpoint stall state. More...
void | USBD_Open (const S_USBD_INFO_T *param, CLASS_REQ pfnClassReq, SET_INTERFACE_REQ pfnSetInterface)
| This function makes USBD module to be ready to use. More...
void | USBD_Start (void)
| This function makes USB host to recognize the device. More...
void | USBD_GetSetupPacket (uint8_t *buf)
| Get the received SETUP packet. More...
void | USBD_ProcessSetupPacket (void)
| Process SETUP packet. More...
void | USBD_StandardRequest (void)
| Process standard request. More...
void | USBD_PrepareCtrlIn (uint8_t pu8Buf[], uint32_t u32Size)
| Prepare the first Control IN pipe. More...
void | USBD_CtrlIn (void)
| Repeat Control IN pipe. More...
void | USBD_PrepareCtrlOut (uint8_t *pu8Buf, uint32_t u32Size)
| Prepare the first Control OUT pipe. More...
void | USBD_CtrlOut (void)
| Repeat Control OUT pipe. More...
void | USBD_SwReset (void)
| Reset software flags. More...
void | USBD_SetVendorRequest (VENDOR_REQ pfnVendorReq)
| USBD Set Vendor Request. More...
void | USBD_SetConfigCallback (SET_CONFIG_CB pfnSetConfigCallback)
| The callback function which called when get SET CONFIGURATION request. More...
void | USBD_LockEpStall (uint32_t u32EpBitmap)
| EP stall lock function to avoid stall clear by USB SET FEATURE request. More...
void | USBD_GetDescriptor (void)
| Process GetDescriptor request. More...

## Variables
volatile uint8_t | g_usbd_RemoteWakeupEn
uint8_t | g_usbd_SetupPacket [8] = {0ul}
volatile uint8_t | g_usbd_RemoteWakeupEn = 0ul
const S_USBD_INFO_T * | g_usbd_sInfo
VENDOR_REQ | g_usbd_pfnVendorRequest = NULL
CLASS_REQ | g_usbd_pfnClassRequest = NULL
SET_INTERFACE_REQ | g_usbd_pfnSetInterface = NULL
SET_CONFIG_CB | g_usbd_pfnSetConfigCallback = NULL
uint32_t | g_u32EpStallLock = 0ul

## Detailed Description

## Macro Definition Documentation

## ◆ USBD_CLR_EP_STALL

#define USBD_CLR_EP_STALL | ( |  | ep | ) |

Clear USB endpoint stall state.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.

Returns
  None

Clear USB endpoint stall state for the specified endpoint ID. Endpoint will respond ACK/NAK token.

Definition at line 521 of file usbd.h.

## ◆ USBD_CLR_INT_FLAG

#define USBD_CLR_INT_FLAG | ( |  | flag | ) |

Clear USB interrupt flag.

Parameters

  [in] | flag | The combination of the specified interrupt flags. Each bit corresponds to a interrupt source. This parameter decides which interrupt flags will be cleared. (USBD_INTSTS_WAKEUP, USBD_INTSTS_FLDET, USBD_INTSTS_BUS, USBD_INTSTS_USB)

Returns
  None

Clear USB related interrupt flags specified by flag parameter.

Definition at line 352 of file usbd.h.

## ◆ USBD_CLR_SE0

#define USBD_CLR_SE0 | ( |  | ) |

Disable SE0.

Parameters

  None |

Returns
  None

Clear DRVSE0 bit of USB_DRVSE0 register to disable software-disconnect function.

Definition at line 286 of file usbd.h.

## ◆ USBD_CONFIG_EP

#define USBD_CONFIG_EP | ( |  | ep,
|  |  | config
| ) |  |

Configure endpoint.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.
  [in] | config | The USB configuration.

Returns
  None

This macro will write config parameter to USB_CFGx register of specified endpoint ID.

Definition at line 471 of file usbd.h.

## ◆ USBD_DISABLE_PHY

#define USBD_DISABLE_PHY | ( |  | ) |

Disable USB PHY.

Parameters

  None |

Returns
  None

To set USB ATTR control register to disable USB PHY.

Definition at line 262 of file usbd.h.

## ◆ USBD_DISABLE_USB

#define USBD_DISABLE_USB | ( |  | ) |

Disable USB.

Parameters

  None |

Returns
  None

To set USB ATTR control register to disable USB.

Definition at line 238 of file usbd.h.

## ◆ USBD_ENABLE_INT

#define USBD_ENABLE_INT | ( |  | intr | ) |

Enable USB interrupt function.

Parameters

  [in] | intr | The combination of the specified interrupt enable bits. Each bit corresponds to a interrupt enable bit. This parameter decides which interrupts will be enabled. (USBD_INT_WAKEUP, USBD_INT_FLDET, USBD_INT_USB, USBD_INT_BUS)

Returns
  None

Enable USB related interrupt functions specified by intr parameter.

Definition at line 325 of file usbd.h.

## ◆ USBD_ENABLE_PHY

#define USBD_ENABLE_PHY | ( |  | ) |

Enable USB PHY.

Parameters

  None |

Returns
  None

To set USB ATTR control register to enable USB PHY.

Definition at line 250 of file usbd.h.

## ◆ USBD_ENABLE_USB

#define USBD_ENABLE_USB | ( |  | ) |

Enable USB.

Parameters

  None |

Returns
  None

To set USB ATTR control register to enable USB and PHY.

Definition at line 226 of file usbd.h.

## ◆ USBD_GET_ADDR

#define USBD_GET_ADDR | ( |  | ) |

Get USB device address.

Parameters

  None |

Returns
  USB device address

Read USB_FADDR register to get USB device address.

Definition at line 310 of file usbd.h.

## ◆ USBD_GET_BUS_STATE

#define USBD_GET_BUS_STATE | ( |  | ) |

Get USB bus state.

Parameters

  None |

Returns
  The value of USB_ATTR[3:0]. Bit 0 indicates USB bus reset status. Bit 1 indicates USB bus suspend status. Bit 2 indicates USB bus resume status. Bit 3 indicates USB bus time-out status.

Return USB_ATTR[3:0] for USB bus events.

Definition at line 380 of file usbd.h.

## ◆ USBD_GET_EP_BUF_ADDR

#define USBD_GET_EP_BUF_ADDR | ( |  | ep | ) |

Get the offset of the specified USB endpoint buffer.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.

Returns
  The offset of the specified endpoint buffer.

This macro will return the SRAM offset of the specified endpoint ID.

Definition at line 497 of file usbd.h.

## ◆ USBD_GET_EP_FLAG

#define USBD_GET_EP_FLAG | ( |  | ) |

Get endpoint status.

Parameters

  None |

Returns
  The value of USB_EPSTS register.

Return all endpoint status.

Definition at line 364 of file usbd.h.

## ◆ USBD_GET_EP_STALL

#define USBD_GET_EP_STALL | ( |  | ep | ) |

Get USB endpoint stall state.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.

Return values

  0 | USB endpoint is not stalled.
  Others | USB endpoint is stalled.

Get USB endpoint stall state of the specified endpoint ID.

Definition at line 534 of file usbd.h.

## ◆ USBD_GET_INT_FLAG

#define USBD_GET_INT_FLAG | ( |  | ) |

Get interrupt status.

Parameters

  None |

Returns
  The value of USB_INTSTS register

Return all interrupt flags of USB_INTSTS register.

Definition at line 337 of file usbd.h.

## ◆ USBD_GET_PAYLOAD_LEN

#define USBD_GET_PAYLOAD_LEN | ( |  | ep | ) |

Get USB payload size (OUT data)

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 endpoint ID. This parameter could be 0 ~ 11.

Returns
  The value of USB_MXPLDx register.

Get the data length of OUT data transaction by reading USB_MXPLDx register.

Definition at line 457 of file usbd.h.

## ◆ USBD_IS_ATTACHED

#define USBD_IS_ATTACHED | ( |  | ) |

Check cable connection state.

Parameters

  None |

Return values

  0 | USB cable is not attached.
  1 | USB cable is attached.

Check the connection state by FLDET bit of USB_FLDET register.

Definition at line 393 of file usbd.h.

## ◆ USBD_Maximum

#define USBD_Maximum | ( |  | a,
|  |  | b
| ) |  |

Compare two input numbers and return maximum one.

Parameters

  [in] | a | First number to be compared.
  [in] | b | Second number to be compared.

Returns
  Maximum value between a and b.

If a > b, then return a. Otherwise, return b.

Definition at line 199 of file usbd.h.

## ◆ USBD_Minimum

#define USBD_Minimum | ( |  | a,
|  |  | b
| ) |  |

Compare two input numbers and return minimum one.

Parameters

  [in] | a | First number to be compared
  [in] | b | Second number to be compared

Returns
  Minimum value between a and b

If a < b, then return a. Otherwise, return b.

Definition at line 213 of file usbd.h.

## ◆ USBD_SET_ADDR

#define USBD_SET_ADDR | ( |  | addr | ) |

Set USB device address.

Parameters

  [in] | addr | The USB device address.

Returns
  None

Write USB device address to USB_FADDR register.

Definition at line 298 of file usbd.h.

## ◆ USBD_SET_DATA0

#define USBD_SET_DATA0 | ( |  | ep | ) |

Set USB DATA0 PID for the specified endpoint ID.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.

Returns
  None

Clear DSQ_SYNC bit of USB_CFGx register to specify the DATA0 PID for the following IN token transaction. Base on this setting, hardware will toggle PID between DATA0 and DATA1 automatically for IN token transactions.

Definition at line 431 of file usbd.h.

## ◆ USBD_SET_DATA1

#define USBD_SET_DATA1 | ( |  | ep | ) |

Set USB DATA1 PID for the specified endpoint ID.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.

Returns
  None

Set DSQ_SYNC bit of USB_CFGx register to specify the DATA1 PID for the following IN token transaction. Base on this setting, hardware will toggle PID between DATA0 and DATA1 automatically for IN token transactions.

Definition at line 418 of file usbd.h.

## ◆ USBD_SET_EP_BUF_ADDR

#define USBD_SET_EP_BUF_ADDR | ( |  | ep,
|  |  | offset
| ) |  |

Set USB endpoint buffer.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.
  [in] | offset | The SRAM offset.

Returns
  None

This macro will set the SRAM offset for the specified endpoint ID.

Definition at line 485 of file usbd.h.

## ◆ USBD_SET_EP_STALL

#define USBD_SET_EP_STALL | ( |  | ep | ) |

Set USB endpoint stall state.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.

Returns
  None

Set USB endpoint stall state for the specified endpoint ID. Endpoint will respond STALL token automatically.

Definition at line 509 of file usbd.h.

## ◆ USBD_SET_PAYLOAD_LEN

#define USBD_SET_PAYLOAD_LEN | ( |  | ep,
|  |  | size
| ) |  |

Set USB payload size (IN data)

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.
  [in] | size | The transfer length.

Returns
  None

This macro will write the transfer length to USB_MXPLDx register for IN data transaction.

Definition at line 445 of file usbd.h.

## ◆ USBD_SET_SE0

#define USBD_SET_SE0 | ( |  | ) |

Enable SE0. Force USB PHY transceiver to drive SE0.

Parameters

  None |

Returns
  None

Set DRVSE0 bit of USB_DRVSE0 register to enable software-disconnect function. Force USB PHY transceiver to drive SE0 to bus.

Definition at line 274 of file usbd.h.

## ◆ USBD_STOP_TRANSACTION

#define USBD_STOP_TRANSACTION | ( |  | ep | ) |

Stop USB transaction of the specified endpoint ID.

Parameters

  [in] | ep | The USB endpoint ID. M480 Series supports 8 hardware endpoint ID. This parameter could be 0 ~ 11.

Returns
  None

Write 1 to CLRRDY bit of USB_CFGPx register to stop USB transaction of the specified endpoint ID.

Definition at line 405 of file usbd.h.

## Typedef Documentation

## ◆ CLASS_REQ

typedef void(* CLASS_REQ) (void)

Functional pointer type declaration for USB class request callback handler

Definition at line 661 of file usbd.h.

## ◆ SET_CONFIG_CB

typedef void(* SET_CONFIG_CB) (void)

Functional pointer type declaration for USB set configuration request callback handler

Definition at line 663 of file usbd.h.

## ◆ SET_INTERFACE_REQ

typedef void(* SET_INTERFACE_REQ) (uint32_t u32AltInterface)

Functional pointer type declaration for USB set interface request callback handler

Definition at line 662 of file usbd.h.

## ◆ VENDOR_REQ

typedef void(* VENDOR_REQ) (void)

Functional pointer type definition for Vendor class

Definition at line 660 of file usbd.h.

## Function Documentation

## ◆ USBD_ClearStall()

__STATIC_INLINE void USBD_ClearStall | ( | uint8_t | epnum | ) |

Clear USB endpoint stall state.

Parameters

  [in] | epnum | USB endpoint number

Returns
  None

Clear USB endpoint stall state. Endpoint will respond ACK/NAK token.

Definition at line 602 of file usbd.h.

## ◆ USBD_CtrlIn()

void USBD_CtrlIn | ( | void |  | ) |

Repeat Control IN pipe.

Parameters

  None |

Returns
  None

This function processes the remained data of Control IN transfer.

Definition at line 553 of file usbd.c.

## ◆ USBD_CtrlOut()

void USBD_CtrlOut | ( | void |  | ) |

Repeat Control OUT pipe.

Parameters

  None |

Returns
  None

This function processes the successive Control OUT transfer.

Definition at line 629 of file usbd.c.

## ◆ USBD_GetDescriptor()

void USBD_GetDescriptor | ( | void |  | ) |

Process GetDescriptor request.

Parameters

  None |

Returns
  None

Parse GetDescriptor request and perform the corresponding action.

Definition at line 184 of file usbd.c.

## ◆ USBD_GetSetupPacket()

void USBD_GetSetupPacket | ( | uint8_t * | buf | ) |

Get the received SETUP packet.

Parameters

  [in] | buf | A buffer pointer used to store 8-byte SETUP packet.

Returns
  None

Store SETUP packet to a user-specified buffer.

Definition at line 119 of file usbd.c.

## ◆ USBD_GetStall()

__STATIC_INLINE uint32_t USBD_GetStall | ( | uint8_t | epnum | ) |

Get USB endpoint stall state.

Parameters

  [in] | epnum | USB endpoint number

Return values

  0 | USB endpoint is not stalled.
  Others | USB endpoint is stalled.

Get USB endpoint stall state.

Definition at line 635 of file usbd.h.

## ◆ USBD_LockEpStall()

void USBD_LockEpStall | ( | uint32_t | u32EpBitmap | ) |

EP stall lock function to avoid stall clear by USB SET FEATURE request.

Parameters

  [in] | u32EpBitmap | Use bitmap to select which endpoints will be locked

Returns
  None

This function is used to lock relative endpoint to avoid stall clear by SET FEATURE request. If ep stall locked, user needs to reset USB device or re-configure device to clear it.

Definition at line 729 of file usbd.c.

## ◆ USBD_MemCopy()

__STATIC_INLINE void USBD_MemCopy | ( | uint8_t | dest[],
|  | uint8_t | src[],
|  | uint32_t | size
| ) |  |

To support byte access between USB SRAM and system SRAM.

Parameters

  [in] | dest | Destination pointer.
  [in] | src | Source pointer.
  [in] | size | Byte count.

Returns
  None

This function will copy the number of data specified by size and src parameters to the address specified by dest parameter.

Definition at line 550 of file usbd.h.

## ◆ USBD_Open()

void USBD_Open | ( | const S_USBD_INFO_T * | param,
|  | CLASS_REQ | pfnClassReq,
|  | SET_INTERFACE_REQ | pfnSetInterface
| ) |  |

This function makes USBD module to be ready to use.

Parameters

  [in] | param | The structure of USBD information.
  [in] | pfnClassReq | USB Class request callback function.
  [in] | pfnSetInterface | USB Set Interface request callback function.

Returns
  None

This function will enable USB controller, USB PHY transceiver and pull-up resistor of USB_D+ pin. USB PHY will drive SE0 to bus.

Definition at line 72 of file usbd.c.

## ◆ USBD_PrepareCtrlIn()

void USBD_PrepareCtrlIn | ( | uint8_t | pu8Buf[],
|  | uint32_t | u32Size
| ) |  |

Prepare the first Control IN pipe.

Parameters

  [in] | pu8Buf | The pointer of data sent to USB host.
  [in] | u32Size | The IN transfer size.

Returns
  None

Prepare data for Control IN transfer.

Definition at line 518 of file usbd.c.

## ◆ USBD_PrepareCtrlOut()

void USBD_PrepareCtrlOut | ( | uint8_t * | pu8Buf,
|  | uint32_t | u32Size
| ) |  |

Prepare the first Control OUT pipe.

Parameters

  [in] | pu8Buf | The pointer of data received from USB host.
  [in] | u32Size | The OUT transfer size.

Returns
  None

This function is used to prepare the first Control OUT transfer.

Definition at line 611 of file usbd.c.

## ◆ USBD_ProcessSetupPacket()

void USBD_ProcessSetupPacket | ( | void |  | ) |

Process SETUP packet.

Parameters

  None |

Returns
  None

Parse SETUP packet and perform the corresponding action.

Definition at line 134 of file usbd.c.

## ◆ USBD_SetConfigCallback()

void USBD_SetConfigCallback | ( | SET_CONFIG_CB | pfnSetConfigCallback | ) |

The callback function which called when get SET CONFIGURATION request.

Parameters

  [in] | pfnSetConfigCallback | Callback function pointer for SET CONFIGURATION request

Returns
  None

This function is used to set the callback function which will be called at SET CONFIGURATION request.

Definition at line 713 of file usbd.c.

## ◆ USBD_SetStall()

__STATIC_INLINE void USBD_SetStall | ( | uint8_t | epnum | ) |

Set USB endpoint stall state.

Parameters

  [in] | epnum | USB endpoint number

Returns
  None

Set USB endpoint stall state. Endpoint will respond STALL token automatically.

Definition at line 571 of file usbd.h.

## ◆ USBD_SetVendorRequest()

void USBD_SetVendorRequest | ( | VENDOR_REQ | pfnVendorReq | ) |

USBD Set Vendor Request.

Parameters

  [in] | pfnVendorReq | Vendor Request Callback Function

Returns
  None

This function is used to set USBD vendor request callback function

Definition at line 699 of file usbd.c.

## ◆ USBD_StandardRequest()

void USBD_StandardRequest | ( | void |  | ) |

Process standard request.

Parameters

  None |

Returns
  None

Parse standard request and perform the corresponding action.

Definition at line 309 of file usbd.c.

## ◆ USBD_Start()

void USBD_Start | ( | void |  | ) |

This function makes USB host to recognize the device.

Parameters

  None |

Returns
  None

Enable WAKEUP, FLDET, USB and BUS interrupts. Disable software-disconnect function after 100ms delay with SysTick timer.

Definition at line 96 of file usbd.c.

## ◆ USBD_SwReset()

void USBD_SwReset | ( | void |  | ) |

Reset software flags.

Parameters

  None |

Returns
  None

This function resets all variables for protocol and resets USB device address to 0.

Definition at line 667 of file usbd.c.

## Variable Documentation

## ◆ g_u32EpStallLock

uint32_t g_u32EpStallLock = 0ul

Bit map flag to lock specified EP when SET_FEATURE

Definition at line 59 of file usbd.c.

## ◆ g_usbd_pfnClassRequest

CLASS_REQ g_usbd_pfnClassRequest = NULL

USB Class Request Functional Pointer

Definition at line 56 of file usbd.c.

## ◆ g_usbd_pfnSetConfigCallback

SET_CONFIG_CB g_usbd_pfnSetConfigCallback = NULL

USB Set configuration callback function pointer

Definition at line 58 of file usbd.c.

## ◆ g_usbd_pfnSetInterface

SET_INTERFACE_REQ g_usbd_pfnSetInterface = NULL

USB Set Interface Functional Pointer

Definition at line 57 of file usbd.c.

## ◆ g_usbd_pfnVendorRequest

VENDOR_REQ g_usbd_pfnVendorRequest = NULL

USB Vendor Request Functional Pointer

Definition at line 55 of file usbd.c.

## ◆ g_usbd_RemoteWakeupEn [1/2]

volatile uint8_t g_usbd_RemoteWakeupEn = 0ul

Remote wake up function enable flag

Definition at line 33 of file usbd.c.

## ◆ g_usbd_RemoteWakeupEn [2/2]

volatile uint8_t g_usbd_RemoteWakeupEn

Remote wake up function enable flag

Definition at line 33 of file usbd.c.

## ◆ g_usbd_SetupPacket

uint8_t g_usbd_SetupPacket[8] = {0ul}

Setup packet buffer

Definition at line 32 of file usbd.c.

## ◆ g_usbd_sInfo

const S_USBD_INFO_T* g_usbd_sInfo

A pointer for USB information structure

Definition at line 53 of file usbd.c.